sk.baka.ambient.collection.local
Class LibraryCollection

java.lang.Object
  extended by sk.baka.ambient.collection.local.LibraryCollection
All Implemented Interfaces:
ICollection

public final class LibraryCollection
extends java.lang.Object
implements ICollection

Collection strategy which uses local database (the Library).

Author:
Martin Vysny

Constructor Summary
LibraryCollection(Library l)
          Creates new collection wrapper.
 
Method Summary
 CategoryItem deserializeItem(java.lang.String id)
          Deserializes item serialized by ICollection.serializeItem(CategoryItem).
 void filterOrigin(TrackOriginEnum origin)
          Show tracks only with given origin.
 java.util.List<TrackMetadataBean> findTracks(java.util.Map<CategoryEnum,java.lang.String> criteria)
          Search for tracks using given criteria search.
 java.util.List<TrackMetadataBean> findTracks(java.lang.String substring)
          A simpler version of ICollection.findTracks(Map).
 java.util.Map<java.lang.String,java.lang.String> fixLocations(java.util.Collection<java.lang.String> locations)
           Given locations became invalid and need fixing.
 java.util.List<CategoryItem> getCategoryList(CategoryEnum request, CategoryItem context, java.lang.String substring, boolean sortByYear)
          Returns category list matching given criteria.
 java.lang.String getName()
          Returns short descriptive name of this collection backend.
 Statistics getStatistics()
          Returns statistics for this collection.
 java.util.List<TrackMetadataBean> getTracks(CategoryItem context)
          Returns all tracks contained in given category.
 boolean isLocal()
          Checks if the underlying strategy uses local resources to retrieve metadata (a DB backend), or it uses remote access to a server (for example Ampache).
 IDynamicPlaylistTrackProvider newTrackProvider(Random random)
          Returns a new instance of the track provider.
 java.lang.String serializeItem(CategoryItem item)
          Returns ID returned by this collection in the CategoryItem.id as String.
 boolean supportsLocationFix()
          Serves for optimalization purposes only: checks if this collection can perform obsolete locations fixup or not.
 
Methods inherited from class java.lang.Object
clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait
 

Constructor Detail

LibraryCollection

public LibraryCollection(Library l)
Creates new collection wrapper.

Parameters:
l - the library to wrap.
Method Detail

getCategoryList

public java.util.List<CategoryItem> getCategoryList(CategoryEnum request,
                                                    CategoryItem context,
                                                    java.lang.String substring,
                                                    boolean sortByYear)
                                             throws java.lang.InterruptedException
Description copied from interface: ICollection
Returns category list matching given criteria. Returns sorted list, either by name or by the year.

Specified by:
getCategoryList in interface ICollection
Parameters:
request - the category to search for. Must not be null.
context - search in context of this item. May be null - in this case all categories are returned.
substring - if not null then all category names must contain this substring.
sortByYear - if true then the result category list is sorted by year, then by CategoryItem.sortKey. If false then sorted only by CategoryItem.sortKey. Ignored when the request parameter is not an album.
Returns:
list of categories. Must not be null, may be empty. Not required to be thread-safe. Sorted depending on the value of the sortByYear parameter.
Throws:
java.lang.InterruptedException - when interrupted.

getTracks

public java.util.List<TrackMetadataBean> getTracks(CategoryItem context)
                                            throws java.lang.InterruptedException
Description copied from interface: ICollection
Returns all tracks contained in given category.

Specified by:
getTracks in interface ICollection
Parameters:
context - search in context of this item. Must not be null.
Returns:
list of tracks, sorted in no particular order. Must not be null, may be empty. Not required to be thread-safe. Sorted in no particular order.
Throws:
java.lang.InterruptedException - when interrupted.

findTracks

public java.util.List<TrackMetadataBean> findTracks(java.lang.String substring)
                                             throws java.lang.InterruptedException
Description copied from interface: ICollection
A simpler version of ICollection.findTracks(Map). Search song which Song Title, Artist Name, Album Name or Genre Name contains given substring.

Specified by:
findTracks in interface ICollection
Parameters:
substring - the substring to search for.
Returns:
the list of tracks. Must not be null, may be empty. Sorted in no particular order. Not required to be thread-safe.
Throws:
java.lang.InterruptedException - when interrupted.

isLocal

public boolean isLocal()
Description copied from interface: ICollection
Checks if the underlying strategy uses local resources to retrieve metadata (a DB backend), or it uses remote access to a server (for example Ampache).

Specified by:
isLocal in interface ICollection
Returns:
true if the collection queries will tend to be performed fast, false otherwise.

getName

public java.lang.String getName()
Description copied from interface: ICollection
Returns short descriptive name of this collection backend.

Specified by:
getName in interface ICollection
Returns:
the name.

filterOrigin

public void filterOrigin(TrackOriginEnum origin)
Show tracks only with given origin.

Parameters:
origin - the origin or null if tracks will be shown regardless of their origin.

getStatistics

public Statistics getStatistics()
Description copied from interface: ICollection
Returns statistics for this collection.

Specified by:
getStatistics in interface ICollection
Returns:
the statistics object, must not be null.

deserializeItem

public CategoryItem deserializeItem(java.lang.String id)
Description copied from interface: ICollection
Deserializes item serialized by ICollection.serializeItem(CategoryItem). This item will be used to perform search only. This functionality is only used by AmpacheServer. You do not need to store the CategoryItem.category - it will be overwritten.

Specified by:
deserializeItem in interface ICollection
Parameters:
id - the item to deserialize
Returns:
the ID instance.

serializeItem

public java.lang.String serializeItem(CategoryItem item)
Description copied from interface: ICollection
Returns ID returned by this collection in the CategoryItem.id as String. This item will only be used to perform searches - you should thus preserve minimum information from the category item. This functionality is only used by AmpacheServer. You do not need to store the CategoryItem.category - it will be overwritten.

Specified by:
serializeItem in interface ICollection
Parameters:
item - the item to convert
Returns:
string representation of given item.

newTrackProvider

public IDynamicPlaylistTrackProvider newTrackProvider(Random random)
Description copied from interface: ICollection
Returns a new instance of the track provider. May return null if this collection does not provide this functionality. It is caller's responsibility to close the provider.

Specified by:
newTrackProvider in interface ICollection
Parameters:
random - initially provide tracks using this random value.
Returns:
new provider instance, may be null.

findTracks

public java.util.List<TrackMetadataBean> findTracks(java.util.Map<CategoryEnum,java.lang.String> criteria)
Description copied from interface: ICollection
Search for tracks using given criteria search.

Specified by:
findTracks in interface ICollection
Parameters:
criteria - the criteria, must not be null. AND operator is used if multiple criteria are specified. String values are matched as substrings.
Returns:
tracks that comply given criteria, in no particular order. Not required to be thread-safe.

fixLocations

public java.util.Map<java.lang.String,java.lang.String> fixLocations(java.util.Collection<java.lang.String> locations)
Description copied from interface: ICollection

Given locations became invalid and need fixing.

MediaPlayer detected an error while playing first location URL from given location list. All given locations might thus have become invalid. The collection is asked to fix these locations: it should re-connect to the server (if any) and/or perform any required steps. If any of these locations became completely invalid the method is free to omit them in the result map. If the collection is unable to fix given location then just pass input location.

Invoked asynchronously. This method will receive only locations provided earlier by track lookup methods such as ICollection.findTracks(Map).

Specified by:
fixLocations in interface ICollection
Parameters:
locations - the list of (possibly) invalid locations. Never null nor empty.
Returns:
a map of locations, maps original location to a fixed locations. Must not be null. Not required to be thread-safe.

supportsLocationFix

public boolean supportsLocationFix()
Description copied from interface: ICollection
Serves for optimalization purposes only: checks if this collection can perform obsolete locations fixup or not.

Specified by:
supportsLocationFix in interface ICollection
Returns:
true if ICollection.fixLocations(Collection) is supported, false if the collection cannot fix the locations, or the fix operation is not applicable to this collection.


Copyright © 2007-2009. All Rights Reserved.